"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultTsxRenderMiddleware = void 0;
const react_1 = __importDefault(require("react"));
const server_1 = __importDefault(require("react-dom/server"));
const tsx_render_middleware_1 = require("./tsx-render.middleware");
/**
 * All Concrete Handlers either handle a request or pass it to the next handler
 * in the chain.
 */
class DefaultTsxRenderMiddleware extends tsx_render_middleware_1.TsxRenderMiddleware {
    createElement(context) {
        context.element = react_1.default.createElement(context.component, context.vars);
        return super.createElement(context);
    }
    async render(context) {
        if (!context.isRendered && context.element) {
            context.html = server_1.default.renderToStaticMarkup(context.element);
        }
        return super.render(context);
    }
}
exports.DefaultTsxRenderMiddleware = DefaultTsxRenderMiddleware;
//# sourceMappingURL=default-render.middleware.js.map